﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.Game
{
    public class Game
    {
        public Player CurentPlayer { get; set; }

        public Map NameMap { get; set; }

        public De De1 {  get; set; }
        public De De2 {  get; set; }

        public int Turn { get; set; }

        public Rules.Rules rules { get; set; }


        public Game(Player player,Map map)
        {
            NameMap = map;
            CurentPlayer = player;
            De1 = new De();
            De2 = new De(1);
            Turn = 0;
            rules = new Rules.Rules();
        }

        public void ThrowDice()
        {
            De1.Lancer();
            De2.Lancer();
        }

        public int ResultOperation(Operation o)
        {
            switch (o)
            {
                case Operation.LOWER:
                    if (De1.IsLower(De2))
                    {
                        return De1.Nb;
                    }
                    return De2.Nb;

                case Operation.HIGHER:
                    if (De1.IsLower(De2))
                    {
                        return De2.Nb;
                    }
                    return De1.Nb;

                case Operation.SUBTRACTION:
                    if (De1.IsLower(De2))
                    {
                        return De2.Nb - De1.Nb;
                    }
                    return De1.Nb - De2.Nb; 

                case Operation.ADDITION:
                    return De2.Nb + De1.Nb;

                case Operation.MULTIPLICATION:
                    return De2.Nb * De1.Nb;
                default:
                    return 0;
            }
        }

        public void PlaceResult (Cell playerChoice,int result)
        {
            if (Turn == 1) 
            {
                playerChoice.Value = result;
            }
            else
            {
                if(rules.NearCell(playerChoice,NameMap.Cells))
                {
                    playerChoice.Value = result;
                }
            }
            return;
        }

        public void AddRopeZone(Cell playerChoice,RopesZones list)
        {
            
        }

    }
}
