﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Models;

namespace Models.Rules
{
    public class ruleBox
    {
        public int HowMany(Cell playerChoice, List<Cell> cells) 
        { 
            foreach(var pos in cells)
            {
                if (pos.Equals(playerChoice))
                {
                    if (pos.GetCellType())
                    {
                        return 6;
                    }
                    return 12;
                }
            }
            return 0;
        }

        public void SetValueAndPenalty(int valueChoice, Cell playerChoice, List<Cell> cells)
        {
            int val = HowMany(playerChoice, cells);
            foreach (var pos in cells)
            {
                if (pos.Equals(playerChoice))
                {
                    if (valueChoice > val)
                    {
                        playerChoice.Background = "notcontent";
                    }
                    playerChoice.Value = valueChoice;
                }
            }
        }

    }
}
